设为首页收藏本站

晓东CAD家园-论坛

 找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 78|回复: 7

[求助] 多重引线的源块属性块的值怎么修改和获取!

[复制链接]

签到天数: 62 天

连续签到: 1 天

[LV.6]常住居民II

发表于 2017-8-12 20:54:16 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有帐号?立即注册

x
多重引线的属性块的值怎么获取修改,纯属性块可以获取修改,但是但是用到多重引线就不行了!
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!

签到天数: 696 天

连续签到: 2 天

[LV.9]以坛为家II

已领礼包: 19个

财富等级: 恭喜发财

发表于 2017-8-12 21:31:52 | 显示全部楼层
论坛好像是讨论过,适当的关键字搜搜
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

签到天数: 480 天

连续签到: 2 天

[LV.9]以坛为家II

已领礼包: 20个

财富等级: 恭喜发财

发表于 2017-8-12 21:41:29 | 显示全部楼层
mleader VLA对象的方法里面有

搜狗截图20170812213621.png

所以,你可以用 vla-getblockattributevalue 获得mleader 属性块的值

例子:

  1. (vl-load-com)
  2. (defun c:Example_BlockAttribute()
  3.     ;; This example creates an MLeader object and gets and sets values for
  4.     ;; the block attribute type.
  5.     (setq acadObj (vlax-get-acad-object))
  6.     (setq doc (vla-get-ActiveDocument acadObj))
  7.   
  8.     (setq points (vlax-make-safearray vlax-vbDouble '(0 . 5)))
  9.     (vlax-safearray-fill points '(0 4 0
  10.                                   1.5 5 0
  11.                                  )
  12.     )
  13.     (setq i 0)
  14.   
  15.     (setq modelSpace (vla-get-ModelSpace doc))  
  16.     (setq oML (vla-AddMLeader modelSpace points i))
  17.    
  18.     (vla-put-ContentType oML acBlockContent)
  19.     (vla-put-ContentBlockType oML acBlockBox)

  20.     (setq sBlock (vla-get-ContentBlockName oML))

  21.     (vlax-for o (vla-Item (vla-get-Blocks doc) sBlock)
  22.         (if (= (vla-get-ObjectName o) "AcDbAttributeDefinition")
  23.                    (progn
  24.                 (vla-SetBlockAttributeValue oML (vla-get-ObjectID o) "123")
  25.                 (alert (vla-GetBlockAttributeValue oML (vla-get-ObjectID o)))
  26.                    )
  27.         )
  28.     )
  29.   
  30.     (vla-Update acadObj)
  31.     (vla-ZoomExtents acadObj)
  32. )


论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

签到天数: 62 天

连续签到: 1 天

[LV.6]常住居民II

 楼主| 发表于 2017-8-12 22:45:14 | 显示全部楼层

找到一个可以用的,但是如果有两个值,不知道怎么改成两个不同的,可以帮我改下么,才学lisp 不怎么会
  • (defun c:data ()
  •   (setq value "值")
  •   (setq ss (ssget ":L" '((0 . "multileader"))))
  •   (setq mleader (ssname ss 0))
  •   (vl-load-com)
  •   ;; ? Lee Mac 2010
  •   (if (and (eq "AcDbMLeader"
  •                (vla-get-objectname
  •                  (setq mleader (cond ((eq 'vla-object (type mleader)) mleader)
  •                                      ((vlax-ename->vla-object mleader))
  •                                )
  •                  )
  •                )
  •            )
  •            (= 1 (vla-get-contenttype mleader))
  •            (setq def (lm:itemp (vla-get-blocks (vla-get-activedocument (vlax-get-acad-object)))
  •                                (vla-get-contentblockname mleader)
  •                      )
  •            )
  •       )
  •     (vlax-for obj def
  •       (if (eq "AcDbAttributeDefinition" (vla-get-objectname obj))
  •         ;; RJP mod to get existing value and add a new value to it
  •         (if (and (setq id (vla-get-objectid obj))
  •                  (setq exval (vla-getblockattributevalue mleader id))
  •             )
  •           (vla-setblockattributevalue mleader id value)
  •         )
  •       )
  •     )
  •   )
  • )




论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

签到天数: 62 天

连续签到: 1 天

[LV.6]常住居民II

 楼主| 发表于 2017-8-12 22:58:19 | 显示全部楼层

  • (defun lm:itemp        (coll item)
  •   ;; ? Lee Mac 2010
  •   (if
  •     (not (vl-catch-all-error-p (setq item (vl-catch-all-apply (function vla-item) (list coll item))))
  •     )
  •      item
  •   )
  • )

论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

签到天数: 1048 天

连续签到: 9 天

[LV.10]以坛为家III

已领礼包: 40个

财富等级: 招财进宝

发表于 2017-8-13 00:56:35 | 显示全部楼层

截取个图片说明下吧,什么样的两个不同的,开始前图片,和你修改后的图片
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

签到天数: 62 天

连续签到: 1 天

[LV.6]常住居民II

 楼主| 发表于 2017-8-13 14:15:17 | 显示全部楼层

TIM图片20170813141056.png
我想要的效果是最后的那样
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

签到天数: 378 天

连续签到: 1 天

[LV.9]以坛为家II

已领礼包: 51个

财富等级: 招财进宝

发表于 2017-8-13 14:25:41 | 显示全部楼层

你普通的块的属性,多个文字的,你是怎么写的代码, 多重引线属性块是一样的写法,因为都是一个函数
vla-setblockattributevalue
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|小黑屋|手机版|Archiver|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )  

GMT+8, 2018-7-17 15:44 , Processed in 0.164843 second(s), 47 queries , Gzip On, WinCache On.

Powered by Discuz! X3.4

© 2001-2017 Comsenz Inc.

快速回复 返回顶部 返回列表